#!/bin/sh
. `dirname $0`/../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo 0 > /sys/class/graphics/fbcon/cursor_blink

echo "select resolution"
echo "================="
echo "1 = 1280 x 1024 Full"
echo "2 = 1280 x 720 HD, with ROI"
echo "3 = 640  x 480 VGA, with ROI"
read RESOLUTION
echo "Your select = $RESOLUTION"
case $RESOLUTION in
  "1") SENSOR_RES="1280x1024"; GRAB_RES="1280x1024"; FRAME_SIZE=",width=1280,height=1024"; OFFSET_SENSOR="(20,12)"; SCALE_SIZE=",width=800,height=640"; KMS_SYNC="true";;
  "2") SENSOR_RES="1280x720"; GRAB_RES="1280x720"; FRAME_SIZE=",width=1280,height=720"; OFFSET_SENSOR="(20,164)"; SCALE_SIZE=",width=800,height=450"; KMS_SYNC="true" ;;
  "3") SENSOR_RES="640x480"; GRAB_RES="640x480"; FRAME_SIZE=",width=640,height=480"; OFFSET_SENSOR="(340,284)"; SCALE_SIZE=",width=640,height=480"; KMS_SYNC="true" ;;
  *) SENSOR_RES="1280x1024"; GRAB_RES="1280x1024"; FRAME_SIZE=",width=1280,height=1024"; OFFSET_SENSOR="(20,12)"; SCALE_SIZE=",width=800,height=640"; KMS_SYNC="true";;
esac

echo "starting gstreamer with $CAM_BW_FMT Source ..."
echo "read $FRAME_SIZE (offset x,y=$OFFSET_SENSOR) and write scaled to framebuffer $SCALE_SIZE"
echo "=============================================================="
echo ""
echo "configure IPU1_CSI0 (camera_0 port) with media_control"
echo "======================================================"

media-ctl -r
media-ctl -l ''$CAM_ENTITY_NUMBER'0->"ipu1_csi0_mux":1[1]'
media-ctl -l "'ipu1_csi0_mux':2->'ipu1_csi0':0[1]"
media-ctl -l "'ipu1_csi0':2->'ipu1_csi0 capture':0[1]"
#           Camera -> IPU1_CSI0_mux -> IPU1-CSI0 -> IPU1-CSI0 capture (/dev/videoX)

media-ctl -V ''$CAM_ENTITY_NUMBER'0 [fmt:Y8/'$GRAB_RES' '$OFFSET_SENSOR'/'$SENSOR_RES']'
media-ctl -V '"ipu1_csi0_mux":2 [fmt:Y8/'$GRAB_RES']'
media-ctl -V '"ipu1_csi0":2 [fmt:Y8/'$GRAB_RES']'

echo ""
echo " configure camera with v4l2_control"
echo " =================================="

v4l2-ctl -d $IPU1_CSI0_DEVICE -c auto_exposure=0

echo ""
echo "start gstreamer, break with ctl-C"
echo "================================="

gst-launch-1.0 \
	v4l2src device=$IPU1_CSI0_DEVICE ! \
	video/x-raw,format=GRAY8,depth=8$FRAME_SIZE ! \
	videoscale ! \
	video/x-raw$SCALE_SIZE ! \
	videoconvert ! \
	queue ! kmssink driver-name="imx-drm" force-modesetting=false can-scale=false sync=$KMS_SYNC
#	fbdevsink sync=false


echo 1 > /sys/class/graphics/fbcon/cursor_blink