#!/bin/sh


. `dirname $0`/../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo 0 > /sys/class/graphics/fbcon/cursor_blink


echo "starting gstreamer with COLOR (YUV in BT656 Mode) Source ..."
echo "read $GRAB_RES (offset x,y=$OFFSET_SENSOR) in two frames (odd,even)"
echo "combine odd/even in IPU, deinterlace with gstreamer and write to framebuffer 752x576"
echo "===================================================================================="
echo ""
echo "configure IPU/VPU with media_control"
echo "===================================="

media-ctl -r
media-ctl -l ''$CAM_ENTITY_NUMBER'0->"ipu1_csi0_mux":1[1]'
media-ctl -l "'ipu1_csi0_mux':2->'ipu1_csi0':0[1]"
media-ctl -l "'ipu1_csi0':2->'ipu1_csi0 capture':0[1]"
#           Camera -> IPU1_CSI0_mux -> IPU1-CSI0 -> IPU1-CSI0 capture (/dev/videoX)

media-ctl -V ''$CAM_ENTITY_NUMBER'0 [fmt:'$CAM_COL_FMT'/'$GRAB_RES' field:interlaced-bt ('$OFFSET_SENSOR')/'$SENSOR_RES_LIVE_DEMO']'
media-ctl -V '"ipu1_csi0_mux":2 [fmt:'$CAM_COL_FMT'/'$GRAB_RES']'
media-ctl -V '"ipu1_csi0":2 [fmt:AYUV8_1X32/'$GRAB_RES' field:none]'


#media-ctl -r
#media-ctl -l ''$CAM_ENTITY_NUMBER'0->"ipu1_csi0_mux":1[1]'
#media-ctl -l "'ipu1_csi0_mux':2 -> 'ipu1_csi0':0[1]"
#media-ctl -l "'ipu1_csi0':1 -> 'ipu1_vdic':0[1]"
#media-ctl -l "'ipu1_vdic':2 -> 'ipu1_ic_prp':0[1]"
#media-ctl -l "'ipu1_ic_prp':2 -> 'ipu1_ic_prpvf':0[1]"
#media-ctl -l "'ipu1_ic_prpvf':1 -> 'ipu1_ic_prpvf capture':0[1]"


#media-ctl -V ''$CAM_ENTITY_NUMBER'0 [fmt:'$CAM_COL_FMT'/'$GRAB_RES' field:interlaced-bt ('$OFFSET_SENSOR')/'$SENSOR_RES_LIVE_DEMO']'
#media-ctl -V "'ipu1_csi0_mux':2 [fmt:UYVY8_2X8/720x576 field:interlaced-bt]"
#media-ctl -V "'ipu1_csi0':1 [fmt:AYUV8_1X32/720x576 field:interlaced-bt]"
#media-ctl -V "'ipu1_vdic':2 [fmt:AYUV8_1X32/720x576 field:none]"
#media-ctl -V "'ipu1_ic_prp':2 [fmt:AYUV8_1X32/720x576 field:none]"
#media-ctl -V "'ipu1_ic_prpvf':1 [fmt:AYUV8_1X32/720x576 field:none]" 
## set right device	v4l2src device=/dev/video1 ! \

echo ""
echo "start gstreamer, break with ctl-C"
echo "================================="

gst-launch-1.0 \
	v4l2src device=$IPU1_CSI0_DEVICE $NORM ! \
	video/x-$COL_FORMAT,width=720,height=576 ! \
	videoconvert ! \
	queue ! kmssink driver-name="imx-drm" force-modesetting=false can-scale=false sync=true

echo 1 > /sys/class/graphics/fbcon/cursor_blink
